// SectionObject.h :  interface of class SectionObject
//

#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <stdio.h>

using namespace std;

typedef int* IntArrayPtr;
typedef double* DoubleArrayPtr;
typedef string* StringArrayPtr;
typedef class PartObject* PartArrayPtr;
typedef class SectionObject* SectionArrayPtr;

class SectionObject
{
public:
	SectionObject();
	SectionObject(int size_PT);
	// set kSEC,ksectionNAME,ksecTextureRUL,ksecColor[3]
	void setkSEC(int i, string& sectionNAME, string& textureURL, double color[]);	
	void setARRAY(int i, int kPAT);											// set section_PT array
	void setCOLOR(int i, double& xRED, double& xGREEN, double& xBLUE);		// set color
	int getNumPT() {return number_PT;}										// get number_PT
	int getSecPT(int kPT) {return section_PT[kPT];}							// get section_PT array
	void printVRML(ofstream& outVRML, int caseNUMBER, int kPAT, int kTYPE);	// printout in *.WRL
	void printXML(ofstream& outVRML, int caseNUMBER, int kPAT, int kTYPE);	// printout in *.X3D
	~SectionObject();
private:
	int kSEC;				// index of this section (set of parts)
	string ksectionNAME;	// name of this section
	string ksecTextureURL;	// textureURL of this section
	double ksecColor[3];	// color of this section
	int number_PT;			// number of parts composing this section
	IntArrayPtr section_PT;	// array to store part indexs composing this section
};