//  Process.h : Interface of Data Processing Menu Option
//

#pragma once


// CProcess CDialog

class CProcess : public CDialog
{
	DECLARE_DYNAMIC(CProcess)

public:
	CProcess(CWnd* pParent = NULL);   // Standard Constructor
	virtual ~CProcess();

// Dialog Box Data
	enum { IDD = IDD_DIALOG1 };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Support

	DECLARE_MESSAGE_MAP()
public:
	CString m_input_dyn_file_name;	// input *.DYN filename w/ extension 
	CString m_input_tme_file_name;	// path of m_input_dyn_file_name
	CString m_input_dyn_file_path;	// input displacement-history filename w/extension
	CString m_input_tme_file_path;	// path of m_input_tme_file_nam
	CString m_output_file_name;		// output filename (*.DAT, *.WRL/*.X3D) w/o extension
	CString m_output_file_path;		// path of m_output_file_name
	CString m_display_file_name;	// display filename => m_output_file_name + ".htm"
	CString m_display_file_path;	// path of m_display_file_name
	int m_iscale_d;		// changed to x3dOption : printout option for VRML = 1, X3D = 2
	double m_vscale_d;	// scale factor for deformed shape 
	int m_iscale_n;		// changed to sColorOption 1: same color 2: different color for deleted part with original part
	double m_vscale_n;	// relative object size in browser
	int m_aoption;		// 1 static VRML (Geometry Only) & 2 dynamic static VRML (Simulation)
	double m_criteria_deletion;	// criteria value for element deletion (elongation)
	afx_msg void OnDataprocessingStart();
	afx_msg void OnBnClickedButton1();
	afx_msg void OnBnClickedButton2();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedOk2();
	afx_msg void OnBnClickedCancel2();
	afx_msg void OnBnClickedOk3();
	afx_msg void OnBnClickedCancel3();
};
