// ShellDisplay.cpp : Implementation of Shell Display Menu Option
//

#include "stdafx.h"
#include "FEMvrml.h"
#include "ShellDisplay.h"


// CShellDisplay ȭ Դϴ.

IMPLEMENT_DYNAMIC(CShellDisplay, CDialog)
CShellDisplay::CShellDisplay(CWnd* pParent /*=NULL*/)
	: CDialog(CShellDisplay::IDD, pParent)
	, m_shell_display_file_name(_T(""))
{
}

CShellDisplay::~CShellDisplay()
{
}

void CShellDisplay::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, m_shell_display_file_name);
}


BEGIN_MESSAGE_MAP(CShellDisplay, CDialog)
	ON_COMMAND(ID_SHELLDISPLAY_OPEN, OnShelldisplayOpen)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
END_MESSAGE_MAP()


// CShellDisplay ޽ óԴϴ.

void CShellDisplay::OnShelldisplayOpen()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CShellDisplay optionDig;
	optionDig.DoModal();
}

void CShellDisplay::OnBnClickedButton1()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "FEM-VRML Files (*.htm)|*.htm;*.TIF|ALL Files(*.*)|*.*||" );
	if (dlg.DoModal () == IDOK) 
	{
		m_shell_display_file_name = dlg.GetFileName();
		m_shell_display_file_path = dlg.GetPathName();
	}
	UpdateData(FALSE);
}

void CShellDisplay::OnBnClickedOk()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	UpdateData();
	ShellExecute(NULL, "open", m_shell_display_file_path, NULL, NULL, SW_SHOW);
}

void CShellDisplay::OnBnClickedCancel()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	OnCancel();
}
